'From Squeak2.8 of 13 June 2000 [latest update: #2348] on 28 July 2000 at 1:51:15 am'!
"Change Set:		LindaTalk-Framework
Date:			28 July 2000
Author:			Robert Withers

LindaTalk Tuple Space System

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the 'Software'), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."!

Error subclass: #LindaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Core'!
Object subclass: #LindaEventThread
	instanceVariableNames: 'isRunning eventSpace process delayMilliseconds '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Events'!
LindaEventThread class
	instanceVariableNames: ''!
Object subclass: #LindaTalkBlocking
	instanceVariableNames: 'tuple bed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Core'!
Process subclass: #LindaTalkProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Core'!
Object subclass: #SharedPriorityQueue
	instanceVariableNames: 'contents accessProtect readSync '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Events'!
SharedPriorityQueue class
	instanceVariableNames: ''!
Object subclass: #Subspace
	instanceVariableNames: 'mutex tuplesIn tuplesOut tuplesRd tuplesEval mixer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Core'!
Subspace subclass: #EventSubspace
	instanceVariableNames: 'parentSpace '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Events'!
EventSubspace class
	instanceVariableNames: ''!
Object subclass: #Tuple
	instanceVariableNames: 'fields '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Core'!
Tuple subclass: #InternalLindaEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Events'!
Tuple subclass: #InternalLindaEventNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Events'!
Tuple subclass: #ResourceEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Events'!
InternalLindaEvent class
	instanceVariableNames: ''!
InternalLindaEventNotification class
	instanceVariableNames: ''!
ResourceEvent class
	instanceVariableNames: ''!
Object subclass: #TupleSpace
	instanceVariableNames: 'subspaces '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Core'!

!TupleSpace commentStamp: '<historical>' prior: 0!
TupleSpace example.
TupleSpace example: 200.
TupleSpace example: 200 priority: Processor userBackgroundPriority.
TupleSpace example: 200 priority: Processor highIOPriority.

!
TupleSpace subclass: #EventTupleSpace
	instanceVariableNames: 'threadPool eventQueue isProcessingEvents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Events'!

!EventTupleSpace commentStamp: '<historical>' prior: 0!
EventTupleSpace example.
EventTupleSpace example: 200.
EventTupleSpace example: 200 threadCount: 4.
EventTupleSpace example: 200 threadCount: 2.
EventTupleSpace example: 200 threadCount: 2 priority: Processor userBackgroundPriority.
EventTupleSpace example: 200 threadCount: 2 priority: Processor highIOPriority.


!
EventTupleSpace class
	instanceVariableNames: ''!
Model subclass: #WhiteboardClient
	instanceVariableNames: 'whiteboardServer whiteboard userName bufferStream '
	classVariableNames: 'Chatter '
	poolDictionaries: ''
	category: 'LindaTalk-Examples'!

!WhiteboardClient commentStamp: '<historical>' prior: 0!
[
	WhiteboardClient exampleHeadlessWhiteboard]
[
	WhiteboardClient exampleMorphicWhiteboard]
!

!Object methodsFor: 'as yet unclassified'!
asTuple
"----------------------------------------------------
     Project:    Linda
    Author:      Marcio Q. Marchini
    Modified: 30/11/93

    Creates a tuple from  a given object
----------------------------------------------------
"

  ^ Tuple with: self! !

!Object methodsFor: 'as yet unclassified'!
| anObject
"
----------------------------------------------------
     Project:    Linda
    Author:      Marcio Q. Marchini
    Modified: 30/11/93

    Creates a tuple with two objects: self and anObject
----------------------------------------------------
"

  ^ Tuple with: self with: anObject! !


!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:03'!
forkLindaTalk
	"Creates a named LindaTalk process"

	^ self forkLindaTalkNamed:  'LindaTalk Process'! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:03'!
forkLindaTalkAt: priority 
	"Creates a named LindaTalk process with a given priority"

	^ self  forkLindaTalkAt:  priority  named: 'LindaTalk Process'! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:04'!
forkLindaTalkAt: priority named: aName
	"Creates a named LindaTalk process with a given priority and name"

	| forkedProcess |                               

	forkedProcess _ self newLindaTalkProcess.
	forkedProcess priority: priority.
	forkedProcess resume. " name: aName "
	^forkedProcess! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:05'!
forkLindaTalkNamed: aName
	"Creates a named LindaTalk process"

	| forkedProcess |
	forkedProcess _ self newLindaTalkProcess.
	forkedProcess resume. " name: aName ; "
	^forkedProcess! !

!BlockContext methodsFor: 'linda stuff' stamp: 'bolot 8/3/1999 14:06'!
newLindaTalkProcess
	"Actually creates a named LindaTalk process"
	^LindaTalkProcess 
		forContext: 
			[self value.
			Processor terminateActive]
		priority: Processor activePriority! !


!Collection methodsFor: 'as yet unclassified'!
asTuple
"----------------------------------------------------
     Project:    Linda
    Author:      Marcio Q. Marchini
    Modified: 30/11/93

    Creates a tuple from a collection of objects
----------------------------------------------------
"

  ^ Tuple new addAll: self; yourself! !


!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 06:30'!
delay
	^ Delay forMilliseconds: delayMilliseconds.! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 06:29'!
delayMilliseconds
	^ delayMilliseconds! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 06:29'!
delayMilliseconds: millis
	delayMilliseconds := millis.
! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 02:00'!
eventSpace
	^ eventSpace
! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 06:30'!
initializeOn: aSpace
	eventSpace _ aSpace.
	isRunning _ false.
	delayMilliseconds := 100.! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 01:59'!
isRunning
	^ isRunning
! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/28/2000 00:38'!
newHandlerProcess
	^[
		self delay wait.
		[self isRunning] 
			whileTrue: [
				[self eventSpace processNextEvent] 
					on: LindaError
					do: [:e | e return].
				self delay wait].
		process := nil.
	] newProcess.
! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 01:59'!
process
	^ process
! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 02:01'!
startHandlingEvents
	isRunning _ true. 
	process _ self newHandlerProcess.
	self process priority: Processor lowIOPriority.
	self process resume! !

!LindaEventThread methodsFor: 'linda' stamp: 'rww 7/26/2000 02:01'!
stopHandlingEvents
	isRunning := false.
! !


!LindaEventThread class methodsFor: 'instance creation' stamp: 'rww 7/26/2000 01:58'!
newOnEventTupleSpace: anEventSpace
	^ self new initializeOn: anEventSpace
! !


!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:27'!
initBed
	"Initializes the Semaphore used to synchronize
	the waiting processes" 
 
	bed := self class newBed! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:27'!
initTuple: aTuple
	tuple _ aTuple! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:28'!
nilBed 
	"Makes nil  the Semaphore used to synchronize
	the waiting processes" 

	bed := nil! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:29'!
sleepProcess 
	"Blocks the current process until
	a match happens. 
	Probably a rd or in." 
	self initBed.
	bed wait. 
	self nilBed! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:29'!
tuple 
	"Returns the tuple which caused the blocking"
	^ tuple ! !

!LindaTalkBlocking methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:29'!
wakeUpProcess 
	"Wakes up the process that was waiting for the tuple. 
	Probably a rd or in."
	bed signal! !


!LindaTalkBlocking class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:30'!
forTuple: aTuple
	"Creates a new LindaTalkBlocking for the given tuple"
	^ self new initTuple: aTuple;
		initBed;
		yourself! !

!LindaTalkBlocking class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:31'!
newBed
	"Returns a new bed for the processes to sleep (a Semaphore)"
	^ Semaphore new! !


!LindaTalkProcess class methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 11:54'!
terminateAll
	"Terminates all LindaTalkProcess"
	self allInstancesDo: [:ltp | ltp suspend ]! !


!ProcessorScheduler methodsFor: 'private' stamp: 'bolot 8/3/1999 11:53'!
anyProcessesAbove: highestPriority 
	"Do any instances of Process exist with higher priorities?"

	^(Process "allInstances" allSubInstances select: [:aProcess | 
		aProcess priority > highestPriority]) isEmpty
		"If anyone ever makes a subclass of Process, be sure to use allSubInstances."! !


!SharedPriorityQueue methodsFor: 'private' stamp: 'rww 7/27/2000 04:06'!
init: initSize

	contents := SortedCollection new: initSize.
	accessProtect := Semaphore forMutualExclusion.
	readSync := Semaphore new.
	self sortBlock: [:a :b | a hash < b hash].
! !

!SharedPriorityQueue methodsFor: 'exceptions'!
errorEmpty

	self error: 'empty queue'.! !

!SharedPriorityQueue methodsFor: 'exceptions'!
errorOutOfSync

	self error: 'internal synchronisation error'.! !

!SharedPriorityQueue methodsFor: 'accessing' stamp: 'rww 7/27/2000 04:05'!
next
	| value |
	readSync wait.
	value := [self nextNoWait]
		on: Error 
		do: [:e | nil]. 
	value isNil ifTrue: [self errorOutOfSync].
	^value! !

!SharedPriorityQueue methodsFor: 'accessing' stamp: 'rww 7/27/2000 04:04'!
nextNoWait
	^ accessProtect critical: [
		contents isEmpty
			ifTrue: [self errorEmpty. nil]
			ifFalse: [contents removeFirst]]
! !

!SharedPriorityQueue methodsFor: 'accessing' stamp: 'rww 7/27/2000 04:04'!
nextPut: aValue
	accessProtect critical: [contents add: aValue].
	readSync signal.
	^aValue! !

!SharedPriorityQueue methodsFor: 'accessing' stamp: 'rww 7/27/2000 04:04'!
peek
	^ accessProtect critical: [contents isEmpty
		ifTrue: [nil]
		ifFalse: [contents first]]
! !

!SharedPriorityQueue methodsFor: 'accessing' stamp: 'rww 7/27/2000 04:03'!
size
	^ accessProtect critical: [contents size]! !

!SharedPriorityQueue methodsFor: 'accessing' stamp: 'rww 7/27/2000 04:05'!
sortBlock: aBlock
	accessProtect critical: [contents sortBlock: aBlock].
! !

!SharedPriorityQueue methodsFor: 'accessing' stamp: 'rww 7/27/2000 04:02'!
subset: limit contentsDo: aBlock
	accessProtect critical: [
		| index |
		index := 1.
		[index <= limit]
			whileTrue: 
				[aBlock value: (contents at: index).
				index := index + 1]].
! !

!SharedPriorityQueue methodsFor: 'testing' stamp: 'rww 7/27/2000 04:03'!
isEmpty
	^ accessProtect critical: [contents isEmpty]! !

!SharedPriorityQueue methodsFor: 'printing' stamp: 'rww 7/27/2000 04:03'!
printOn: aStream

	aStream nextPutAll: 'priority queue => '.
	self size > 0
		ifTrue: [aStream nextPutAll: self size printString , ' events remaining'.
			self printQueueContentsOn: aStream]
		ifFalse: [aStream nextPutAll: 'empty'].! !

!SharedPriorityQueue methodsFor: 'printing' stamp: 'rww 7/27/2000 04:03'!
printQueueContentsOn: aStream 
	| printSize |
	(printSize := self size) > 10 
		ifTrue: [printSize := 10].
	self 
		subset: printSize 
		contentsDo: [:element | 
			aStream cr; tab; 
				nextPutAll: element printString].! !


!SharedPriorityQueue class methodsFor: 'instance creation'!
new

	^self new: 10! !

!SharedPriorityQueue class methodsFor: 'instance creation'!
new: anInitSize 

	^(super new) init: anInitSize; yourself! !


!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:37'!
addInBlocking: blocking
	"Add a new LindaTalkBlocking for the In primitive"

	tuplesIn add: blocking! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:04'!
addLiveTuple: tuple
	"Add the live tuple in the internal partition."
	tuplesEval addLast: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:05'!
addOutTuple: tuple
	"Add the tuple in the corresponding partition.
	Mix the order, so that there is no order relation in the tuple
	space"
	mixer
		ifTrue:  [ tuplesOut addLast: tuple ]
		ifFalse: [ tuplesOut addFirst: tuple ].
	mixer := mixer not.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:05'!
addRdBlocking: blocking
	"Add a new LindaTalkBlocking for the Rd primitive"

	tuplesRd add: blocking! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 19:28'!
copy
	"Returns a copy of the Subspace"
	| copy |

	self mutexBegin.
	copy := super copy zeroTuples.
	self  inBlockings do: [:bloc | copy addInBlocking: bloc copy ].
	self  tuplesOut do: [:t | copy addOutTuple: t copy ].
	self  rdBlockings do: [:bloc | copy addInBlocking: bloc copy].
	self  tuplesEval do: [:t | copy addLiveTuple: t  copy].
	self mutexEnd.
	^ copy! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:02'!
eval: tuple
	"Eval implementation. Call the primitive in the Tuple class.
	That primitive evaluates the blocks in parallel, and then the tuple becomes
	an ordinary tuple, which is outed"

	self class fork: [self liveToOrdinary: ( self runLiveTuple: tuple  )]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:03'!
in: tuple
	"In implementation"

	^ self inWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:03'!
inBlockingThatMatches: tuple
	"Returns the index of the LindaTalkBlocking In
	that matches tuple"

	| i |
	i := 1.
	self inBlockings do:
	[ :bloc |
		(tuple match: bloc tuple)
			ifTrue: [ ^ i ].
		i := i + 1].
	^ 0! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:04'!
inBlockings
	"Returns the collection of LindaTalkBlockings In"

	^ tuplesIn! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:39'!
inNotWaitingTuple: tuple
	"inp. I do not get blocked if tuple is not available"

	^ self inNotWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:41'!
inNotWaitingTupleNoSideEffect: tuple
	"INP  primitive"
	| match tupleOutThatMatched copy |

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: [self mutexEnd.
			^nil]
		ifFalse: ["Found one out tuple that matches"
			tupleOutThatMatched := self removeTupleOut: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:41'!
inWaitingTuple: tuple
	"In implementation. I will be blocked if there is no tuple."
	^ self inWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:42'!
inWaitingTupleNoSideEffect: tuple
	"IN primitive"
	| match tupleOutThatMatched copy blocking|

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: ["No tuple matches. Add a blocking in the in partition "
			blocking :=  LindaTalkBlocking forTuple: copy.
			self addInBlocking: blocking;
				mutexEnd.
			blocking sleepProcess.
			"Out . Someone woke me up ."]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self removeTupleOut: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
initialize
	"Initialize the instance variables.
	A semaphore for mutual exclusion and the 3
	`partitions:  In, Out, Rd."

	mutex := Semaphore new.
	mutex signal.
	self zeroTuples.
	mixer := true. "Mix tuples"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:44'!
inp: tuple
	"Inp implementation"

	^ self inNotWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:44'!
isEmpty
	"Informs if the subspace is empty. That is, no partition has tuples."

	^ (self inBlockings isEmpty) and: [ (self rdBlockings isEmpty) and: [self tuplesOut isEmpty] ]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:44'!
justEval: tuple
	"Just like eval, but the resulting ordinary tuple is discarded
	after evaluation"

	self class fork: [  self runLiveTuple: tuple ]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:45'!
liveToOrdinary: tuple
	"Transforms a live tuple in ordinary"

	self out: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:47'!
mutexBegin
	"Begin of mutual exclusion"

	mutex wait! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:47'!
mutexEnd
	"End of mutual exclusion"

	mutex signal! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:47'!
nthBlockingIn: position
	"Returns the in blocking in the given position"

	^ tuplesIn at: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:48'!
nthBlockingRd: position
	"Returns the rd blocking in the given position"

	^ tuplesRd at: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:48'!
out: tuple
	"Out implementation"

	^ self outPersistentTuple: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:48'!
outNonPersistentTuple: tuple
	"OUTI primitive. If there is any blocked rd or in,
	there will be match. The tuple, however, never
	stays in the space"

	self outNonPersistentTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:49'!
outNonPersistentTupleNoSideEffect: tuple
	"OUTI implementation"
	| match tupleInThatMatched blocking |

	self mutexBegin.
	self wakeUpRdTuplesThatMatch: tuple. "Atention here"
	match := self inBlockingThatMatches: tuple.
	(match = 0 )
		ifFalse: ["Found one that matches. Remove from in partition"
			blocking := self removeInBlocking: match.
			tupleInThatMatched := blocking tupla.
			tuple transferContentsTo: tupleInThatMatched.
			blocking wakeUpProcess].
	self mutexEnd! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:49'!
outPersistentTuple: tuple
	"Out implementation. If there is any rd or in, there
	will be match"

	self outPersistentTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:50'!
outPersistentTupleNoSideEffect: tuple
	"OUT primitive"
	| match tupleInThatMatched blocking|

	self mutexBegin.
	self wakeUpRdTuplesThatMatch: tuple. "Atention here "
	match := self inBlockingThatMatches: tuple.
	(match = 0 )
		ifTrue: ["No tuple matches. Add in the set of out tuples."
			self addOutTuple: tuple;
				wakeUpRdTuplesThatMatch: tuple]
		ifFalse: ["Found one that matches. Remove from the in partition"
			blocking := self removeInBlocking: match.
			tupleInThatMatched := blocking tuple.
			tuple transferContentsTo: tupleInThatMatched.
			blocking wakeUpProcess].
	self mutexEnd! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:50'!
outi: tuple
	"Outi  implementation"

	^ self outNonPersistentTuple: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:50'!
rd: tuple
	"Rd  implementation"

	^ self rdWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:51'!
rdBlockings
	"Returns the collection of LindaTalkBlockings Rd"

	^ tuplesRd! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:10'!
rdNotWaitingTuple: tuple
	"Rdp primitive. I will not  be blocked if there is no tuple available."

	^ self rdNotWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
rdNotWaitingTupleNoSideEffect: tuple
	"Rdp implementation"

	| match tupleOutThatMatched copy|

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: [ self mutexEnd.
			^nil]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self tupleOutInPosition: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:12'!
rdWaitingTuple: tuple
	"Rd implementation. I will be blocked if there is no tuple available"

	^ self rdWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:14'!
rdWaitingTupleNoSideEffect: tuple
	"RD primitive"
	| match tupleOutThatMatched copy  blocking |

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: ["No tuple matches. Add in the rd partition"
			blocking :=  LindaTalkBlocking forTuple: copy.
			self addRdBlocking: blocking;
				mutexEnd.
			blocking sleepProcess.
			"Out. Someone woke me up."]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self tupleOutInPosition: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:14'!
rdp: tuple
	"Rdp  implementation"

	^ self rdNotWaitingTuple: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:14'!
removeInBlocking: position
	"Removes the blocking"

	| bloc |
	bloc := self nthBlockingIn: position.
	self removeTuple: position fromPartition: tuplesIn.
	^ bloc! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:15'!
removeLiveTuple: tuple
	"Removes a given live tuple from its partition"

	tuplesEval remove: tuple ifAbsent: [self error: 'Error in #removeLiveTuple:']! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:15'!
removeRdBlocking: position
	"Removes a rd blocking from the given position"

	| bloc|
	bloc := self nthBlockingRd: position.
	self removeTuple: position fromPartition: tuplesRd.
	^ bloc! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:15'!
removeTuple: position fromPartition: partition
	"Removes a given tuple from a given partition"

	partition removeAt: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
removeTupleOut: position
	"Removes a given out tuple from its partition"

	| t |
	t := self  tupleOutInPosition: position.
	self removeTuple: position fromPartition: tuplesOut.
	^ t! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
runLiveTuple: tuple
	"Live tuple creation kernel"

	| tupleEval |

	self mutexBegin;
		addLiveTuple: tuple;
		mutexEnd.

	tupleEval := tuple copy primEval;
		yourself.

	self mutexBegin;
		removeLiveTuple: tuple;
		mutexEnd.

	^ tupleEval! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
scan: tuple
	"Scan  implementation"

	^ self scanNotWaitingTuple: tuple.! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
scanNotWaitingTuple: tuple
	"Scan primitive. I will not  be blocked if there is no tuple available."

	^ self scanNotWaitingTupleNoSideEffect: tuple! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
scanNotWaitingTupleNoSideEffect: tuple
	"Scan implementation"

	| matches  copy |

	copy := tuple copy.
	self mutexBegin.
	matches := self tuplesOutThatMatches: copy.
	self mutexEnd.
	^ matches! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:17'!
tupleOutInPosition: position
	"Returns the out tuple in the given position"

	^ tuplesOut at: position! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 13:51'!
tupleOutThatMatches: tuple
	"Returns the position of the out
	tuple that matches tuple"

	| i |
	i := 1.
	self tuplesOut do: [ :t |     "The matching is FROM tuple space TO my tuple"
		(t match: tuple )
			ifTrue: [ ^ i ].
				i := i + 1].
	^ 0! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 19:28'!
tuplesEval
	"Returns the eval partition"

	^ tuplesEval! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:18'!
tuplesOut
	"Returns the out partition"

	^ tuplesOut! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 22:30'!
tuplesOutThatMatches: tuple
	"Returns the collection of positions of the out
	tuples that matches tuple"
	 "The matching is FROM tuple space TO my tuple"

	^self tuplesOut 
			select: [ :t | t match: tuple ]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 19:33'!
wakeUpRdTuplesThatMatch: tuple
	"An out happened. Wake up processed that issued rd."

	| i size nthTuple nthBlocking |

	i := 1.
	size := self rdBlockings size.
	[ i > size ]
	whileFalse: [
		nthBlocking := self nthBlockingRd: i.
		nthTuple :=  nthBlocking tuple.
		(tuple match: nthTuple)
			ifTrue: [
				nthBlocking := self removeRdBlocking: i.
				nthTuple :=  nthBlocking tuple.
				tuple transferContentsTo: nthTuple.
				nthBlocking wakeUpProcess.
				size := size - 1]
			ifFalse: [i := i + 1]]! !

!Subspace methodsFor: 'as yet unclassified' stamp: 'rww 7/14/2000 02:04'!
zeroTuples
	"Empties all partitions"

	tuplesIn := OrderedCollection new.
	tuplesRd := OrderedCollection new.
	tuplesOut := OrderedCollection new.
	tuplesEval := OrderedCollection new.! !


!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/26/2000 03:24'!
copy
	"Returns a copy of the Subspace"
	| copy |

	copy := super copy zeroTuples.
	copy initializeOnSpace: self parentSpace.
	^ copy! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 02:50'!
inNotWaitingTupleNoSideEffect: tuple
	"INP  primitive"
	| match tupleOutThatMatched copy |

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: [self mutexEnd.
			^nil]
		ifFalse: ["Found one out tuple that matches"
			tupleOutThatMatched := self removeTupleOut: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	self triggerTupleEvent: #take withParameter: tuple withResult: copy.
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 02:49'!
inWaitingTupleNoSideEffect: tuple
	"IN primitive"
	| match tupleOutThatMatched copy blocking|

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: ["No tuple matches. Add a blocking in the in partition "
			blocking :=  LindaTalkBlocking forTuple: copy.
			self addInBlocking: blocking;
				mutexEnd.
			blocking sleepProcess.
			"Out . Someone woke me up ."]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self removeTupleOut: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	self triggerTupleEvent: #take withParameter: tuple withResult: copy.
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 04:16'!
outNonPersistentTupleNoSideEffect: tuple
	"OUTI implementation"
	| match tupleInThatMatched blocking |

	self mutexBegin.
	self wakeUpRdTuplesThatMatch: tuple. "Atention here"
	match := self inBlockingThatMatches: tuple.
	(match = 0 )
		ifFalse: ["Found one that matches. Remove from in partition"
			blocking := self removeInBlocking: match.
			tupleInThatMatched := blocking tuple.
			tuple transferContentsTo: tupleInThatMatched.
			blocking wakeUpProcess].
	self mutexEnd.

	self 
		triggerTupleEvent: #write 
		withParameter: tuple 
		withResult: tuple.
! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 02:49'!
outPersistentTupleNoSideEffect: tuple
	"OUT primitive"
	| match tupleInThatMatched blocking|

	self mutexBegin.
	self wakeUpRdTuplesThatMatch: tuple. "Atention here "
	match := self inBlockingThatMatches: tuple.
	(match = 0 )
		ifTrue: ["No tuple matches. Add in the set of out tuples."
			self addOutTuple: tuple;
				wakeUpRdTuplesThatMatch: tuple]
		ifFalse: ["Found one that matches. Remove from the in partition"
			blocking := self removeInBlocking: match.
			tupleInThatMatched := blocking tuple.
			tuple transferContentsTo: tupleInThatMatched.
			blocking wakeUpProcess].
	self mutexEnd.

	self triggerTupleEvent: #write withParameter: tuple withResult: tuple.
! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 02:49'!
rdNotWaitingTupleNoSideEffect: tuple
	"Rdp implementation"

	| match tupleOutThatMatched copy|

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: [ self mutexEnd.
			^nil]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self tupleOutInPosition: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	self triggerTupleEvent: #read withParameter: tuple withResult: copy.
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 02:48'!
rdWaitingTupleNoSideEffect: tuple
	"RD primitive"
	| match tupleOutThatMatched copy  blocking |

	copy := tuple copy.
	self mutexBegin.
	match := self tupleOutThatMatches: copy.
	(match = 0)
		ifTrue: ["No tuple matches. Add in the rd partition"
			blocking :=  LindaTalkBlocking forTuple: copy.
			self addRdBlocking: blocking;
				mutexEnd.
			blocking sleepProcess.
			"Out. Someone woke me up."]
		ifFalse: ["Found one that matches"
			tupleOutThatMatched := self tupleOutInPosition: match.
			tupleOutThatMatched transferContentsTo: copy.
			self mutexEnd].

	self triggerTupleEvent: #read withParameter: tuple withResult: copy.
	^ copy
	"Modified by the match, but the original tuple is not changed"! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 02:48'!
runLiveTuple: tuple
	"Live tuple creation kernel"

	| tupleEval |

	self mutexBegin;
		addLiveTuple: tuple;
		mutexEnd.

	tupleEval := tuple copy primEval;
		yourself.

	self mutexBegin;
		removeLiveTuple: tuple;
		mutexEnd.

	self triggerTupleEvent: #eval withParameter: tuple withResult: tupleEval.
	^ tupleEval! !

!EventSubspace methodsFor: 'overrides' stamp: 'rww 7/27/2000 02:48'!
scanNotWaitingTupleNoSideEffect: tuple
	"Scan implementation"

	| matches  copy |

	copy := tuple copy.
	self mutexBegin.
	matches := self tuplesOutThatMatches: copy.
	self mutexEnd.

	self triggerTupleEvent: #scan withParameter: copy withResult: matches.
	^ matches! !

!EventSubspace methodsFor: 'events' stamp: 'rww 7/26/2000 02:47'!
initializeOnSpace: aTupleSpace
	parentSpace := aTupleSpace.
! !

!EventSubspace methodsFor: 'events' stamp: 'rww 7/26/2000 02:25'!
parentSpace
	^ parentSpace! !

!EventSubspace methodsFor: 'events' stamp: 'rww 7/27/2000 04:42'!
triggerTupleEvent: anEventSymbol withParameter: tuple withResult: result
	"Returns the position of the out
	tuple that matches tuple"

	| event |
	(tuple respondsTo: #priority)
		ifTrue: [event := InternalLindaEvent
			eventSymbol: anEventSymbol
			tuple: tuple
			result: result
			priority: tuple priority]
		ifFalse: [event := InternalLindaEvent
			eventSymbol: anEventSymbol
			tuple: tuple
			result: result].
	self parentSpace enqueueEvent: event.

! !


!Subspace class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:36'!
evalDefaultPriority
	"Returns the default process priority"

	^ Processor  userBackgroundPriority! !

!Subspace class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:37'!
fork: aBlock
	"Creates the eval processes"

	^ aBlock forkLindaTalkAt: self evalDefaultPriority! !

!Subspace class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 22:37'!
new
	"Creates and returns a new subspace"

	^ super new initialize! !


!EventSubspace class methodsFor: 'instance creation' stamp: 'rww 7/26/2000 02:46'!
newForSpace: aTupleSpace
	^ self new initializeOnSpace: aTupleSpace
! !


!Tuple methodsFor: 'Linda API' stamp: 'rww 7/27/2000 08:58'!
eval: contextTupleSpace 
	"eval in the given tuple space"

	^ contextTupleSpace eval: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/2/1999 23:28'!
in: aTupleSpace 
	"In at the given tuple space"

	^ aTupleSpace in: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/2/1999 23:29'!
inp: aTupleSpace 
	"inp in the given tuple space"

	^ aTupleSpace inp: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/3/1999 00:03'!
out: aTupleSpace
	"out in the given tuple space"

	^ aTupleSpace out: self! !

!Tuple methodsFor: 'Linda API' stamp: 'rww 7/27/2000 23:22'!
outi: aTupleSpace
	"outi in the given tuple space"

	^ aTupleSpace outi: self! !

!Tuple methodsFor: 'Linda API' stamp: 'rww 7/27/2000 19:18'!
primEval
	"The actual eval.
	Forks the blocks in parallel, and replaces the
	parameters after the computations finish"

	| processes sync index|

	processes := Dictionary new.
	sync := Semaphore new.
	index := 1.
	self do: [:p |
		(p isKindOf: self lindaTalkComputing )
			ifTrue: [ processes at: index put: p].
		index := index + 1].
	"I have index->process"

	processes associationsDo: [:assoc |
		self fork: assoc value
			parameter: assoc key
			synchronizingIn: sync].

	processes keysDo: [:k | sync wait ]. "Wait all finish"! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/3/1999 00:07'!
rd: aTupleSpace 
	"rd in the given tuple space"

	^ aTupleSpace rd: self! !

!Tuple methodsFor: 'Linda API' stamp: 'bolot 8/3/1999 00:08'!
rdp: aTupleSpace 
	"rdp in the given tuple space"

	^ aTupleSpace rdp: self! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:24'!
- anIndex
	"Returns a new tuple, which is just like
	the original one, but without the element
	anIndex"

	^ self  copy removeAtIndex: anIndex; yourself! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:24'!
@ anIndex
	"Returns the given parameter"

	^ self at: anIndex! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:24'!
addParameter: aTupleParameter
	"Adds another parameter to the original tuple"

	self add: aTupleParameter! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:25'!
arity
	"Returns the number of elements of the tuple"

	^ self size! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:25'!
asTuple 
	"Returns myself"

	^ self! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:25'!
changeParameter: anIndex by: anObject
	"Changes a given parameter"

	self at: anIndex put: anObject! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:27'!
fork: aBlock parameter: anIndex  synchronizingIn: semaphore
	"Forks a process for the corresponding live parameter.
	When finished, the process signals a semaphore,
	so that the root process which forked the live
	parameters can collect the results and assemble
	the resulting ordinary tuple."

	self class fork:
		[self changeParameter: anIndex by: aBlock value.
		semaphore signal]! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:30'!
isFilter: anObject 
	"Returns true is the object is a filter.
	This is not standard Linda. Filter is a block which
	takes the object as a parameters and returns either true or 
	false. For instance:

	( Integer | [:num | num < 3]) 
		match: 
	(     33  |   2 ) 

	returns true" 

	^ (anObject isKindOf: self lindaTalkFilter) and: [ 1 = anObject numArgs]! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:31'!
isLindaTalkComputing: anObject 
	"Informs if the object is a LindaTalk computing"

	^ (anObject isKindOf: self lindaTalkComputing) and: [ 0 = anObject numArgs]! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:31'!
isPotential: anObject
	"Returns true if the given object is a potential (class)"

	^ anObject isKindOf: Behavior! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:32'!
isPotentialParameter: anIndex
	"Returns true if the given parameter is a potential (class)"

	^ self isPotential: (self at: anIndex )! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:32'!
lindaTalkComputing
	"Returns the class that represents
	a LindaTalk computing. That is, the elements
	in a live tuple"

	^ BlockContext! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/2/1999 23:32'!
lindaTalkFilter
	"Returns the class that represents filters in LindaTalk"

	^ BlockContext! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/3/1999 00:04'!
parameter: anIndex
	"Returns the given tuple parameter (indexed)"

	^ self at: anIndex! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/3/1999 00:07'!
printOn: aStream
	"Shows the tuple"

	aStream nextPutAll: self class name , ':( '.
	1 to: self size do: [:i |
		( self isLindaTalkComputing: (self at: i))
			ifTrue: [ aStream nextPutAll: '[...computing...]' ]
			ifFalse: [
				( self  isFilter: (self at: i))
					ifTrue: [ aStream nextPutAll: ' Filter [:x | ...filter x...]' ]
					ifFalse: [ (self at: i) printOn: aStream]].
		aStream nextPutAll: ' | '].
	aStream skip: -2.
	aStream nextPutAll: ') '! !

!Tuple methodsFor: 'utils' stamp: 'rww 7/27/2000 09:03'!
transferContentsTo: anotherTuple
	"Implements the transfer from reals to potentials"

	| index |
	index := 1.
	anotherTuple  do: [ :p |
		((self isPotential: p) or: [self  isFilter: p])
			ifTrue: [ anotherTuple changeParameter: index
					by: (self parameter: index )].
		index := index + 1]! !

!Tuple methodsFor: 'utils' stamp: 'bolot 8/3/1999 00:10'!
| anElement 
	"Adds another parameter to the original tuple"

	^ self addParameter: anElement; yourself! !

!Tuple methodsFor: 'matching' stamp: 'rww 7/27/2000 23:52'!
= anotherTuple 
	"Returns true if there is equality"

	| pSelf pOther |
	( self arity = anotherTuple arity ) 
		ifFalse: [ ^ false ]. 
 
	1 to: self arity do: [ :i  | 
		pSelf := self parameter: i. 
		pOther := anotherTuple parameter: i. 
		(pSelf = pOther) 
			ifFalse: [ ^ false ]]. 
	^ true! !

!Tuple methodsFor: 'matching' stamp: 'bolot 8/2/1999 23:34'!
match: anotherTuple 
	"Returns true if there is matching"

	| pSelf pOther | 

	( self arity = anotherTuple arity ) 
		ifFalse: [ ^ false ]. 
 
	1 to: self arity do: [ :i  | 
		pSelf := self parameter: i. 
		pOther := anotherTuple parameter: i. 
		(self matchElements: pSelf and: pOther) 
			ifFalse: [ ^ false ]]. 
	^ true! !

!Tuple methodsFor: 'matching' stamp: 'bolot 8/2/1999 23:37'!
matchElements: obj1 and: obj2 
	"Retorna true caso haja 'matching' entre 
	os elementos"

	(obj1 = obj2)   "Equal. There is match" 
		ifTrue: [ ^ true ]. 
 
	(self isPotential: obj1)
		ifFalse:["The first is a real parameter" 
			(self isPotential:obj2 ) 
				ifFalse:["The second is either real or filter.
						If real, both are necessaryly different (because
						of the first test above). There can still be matching
						if the second element is a filter that evaluates true" 
					^ self thereIsConformityFrom: obj1 toFilter: obj2  "Because both are different"]
				ifTrue: [ "And the second is potential" 
					^ self thereIsConformityFrom: obj1 to: obj2]]
		ifTrue:["The second is a potential parameter" 
			(self isPotential:obj2 ) 
				ifTrue:[ "And the second is also potential" 
					^ self  thereIsConformityFromPotential: obj1 to: obj2]
				ifFalse: [ "And the second is real" 
					^ self thereIsConformityFrom: obj2 to: obj1]]! !

!Tuple methodsFor: 'matching' stamp: 'bolot 8/2/1999 23:38'!
matchResultWith: another
	"Returns the new  tuple which is the match result.
	NOT USED YET"

	| result pOther pSelf |
	result _ self class new.
	another  size do: [:i |
		pOther := another parameter: i.
		pSelf := self parameter: i.
		(another isPotential: i)
			ifFalse: [ result addParameter: pOther]
			ifTrue:  [ result addParameter: pSelf]].
	^ result! !

!Tuple methodsFor: 'matching' stamp: 'bolot 8/3/1999 00:08'!
thereIsConformityFrom: anObject to: anotherObject 
	"Returns true if there is conformity from 'anObject' 
	to  'anotherObject'. true if the the first belong
	to the class of the second one (the second one is a class)" 

	^ anObject isKindOf: anotherObject! !

!Tuple methodsFor: 'matching' stamp: 'bolot 8/3/1999 00:09'!
thereIsConformityFrom: obj1  toFilter: obj2 
	"Returns true if there is conformity from 'obj1'
	to  'obj2'. true if the the first evaluates true
	for the block obj2 (1 parameter block)"

	(self  isFilter: obj2 ) 
		ifFalse: [ ^ false]   "No. No conformity" 
		ifTrue: [ ^ true == (obj2 value: obj1)] "Yes. Block returns true"! !

!Tuple methodsFor: 'matching' stamp: 'bolot 8/3/1999 00:09'!
thereIsConformityFromPotential: anObjectPotential to: anotherObjectPotential 
	"Returns true if there is conformity between the potentials"

	^  anObjectPotential == anotherObjectPotential! !

!Tuple methodsFor: 'collection API' stamp: 'rww 7/27/2000 23:30'!
add: aTupleParameter
	"Adds another parameter to the original tuple"

	fields := fields copyWith: aTupleParameter. 
! !

!Tuple methodsFor: 'collection API' stamp: 'rww 7/14/2000 02:04'!
addAll: aParameterCollection
	"Add a collection of parameters to the original tuple"

	aParameterCollection do: [:e | self add: e].! !

!Tuple methodsFor: 'collection API' stamp: 'rww 7/27/2000 23:29'!
at: index
	"Get the parameter at the index"

	^ fields at: index! !

!Tuple methodsFor: 'collection API' stamp: 'rww 7/27/2000 20:34'!
at: index put: aTupleParameter
	"Put the parameter at the index"

	fields at: index put: aTupleParameter.
! !

!Tuple methodsFor: 'collection API' stamp: 'rww 7/27/2000 20:42'!
do: aBlock
	fields do: [:eachField | aBlock value: eachField].! !

!Tuple methodsFor: 'collection API' stamp: 'rww 7/14/2000 02:04'!
size
	^fields size! !

!Tuple methodsFor: 'initialize-release' stamp: 'rww 7/25/2000 00:53'!
initialize
	fields := OrderedCollection new.
	self class defaultArity timesRepeat: [self add: nil].! !


!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:43'!
arguments
	^ Array 
		with: self tuple 
		with: self result
! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/26/2000 03:16'!
eventSymbol
	^ self at: 1
! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/26/2000 03:16'!
eventSymbol: aSymbol
	self at: 1 put: aSymbol.
! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:11'!
priority
	^ self at: 4! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:12'!
priority: aPriority
	self at: 4 put: aPriority.
! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/26/2000 19:59'!
result
	^ self at: 3
! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/26/2000 20:00'!
result: aResult
	self at: 3 put: aResult.
! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/26/2000 03:16'!
tuple
	^ self at: 2
! !

!InternalLindaEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/26/2000 03:17'!
tuple: aTuple
	self at: 2 put: aTuple.
! !


!InternalLindaEventNotification methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:23'!
initializeOnMatch: aTuple messageSend: aMessageSend
	self match: aTuple;
		messageSend: aMessageSend.
! !

!InternalLindaEventNotification methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:25'!
match
	^ self at: 1
! !

!InternalLindaEventNotification methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:24'!
match: aTuple
	self at: 1 put: aTuple.
! !

!InternalLindaEventNotification methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:24'!
messageSend
	^ self at: 2
! !

!InternalLindaEventNotification methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:24'!
messageSend: aMessageSend
	self at: 2 put: aMessageSend.
! !

!InternalLindaEventNotification methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:26'!
receiver
	^ self messageSend
		ifNotNil: [self messageSend receiver]
! !

!InternalLindaEventNotification methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 22:30'!
valueWithArguments: anArgArray
	| targetTuple results |
	(anArgArray size = 2)
		ifFalse: [^nil].
	targetTuple := anArgArray asOrderedCollection first.
	results := anArgArray copyAfter: targetTuple.
	^ (self match match: targetTuple)
		ifTrue: [self messageSend valueWithArguments: results]
		ifFalse: [nil]
! !


!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:50'!
data
	^ self at: 3
! !

!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:50'!
data: theData
	self at: 3 put: theData.
! !

!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:50'!
priority
	^ self at: 4
! !

!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:50'!
priority: aPriority
	self at: 4 put: aPriority.
! !

!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:49'!
resourceName
	^ self at: 1
! !

!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:51'!
resourceName: aName
	self at: 1 put: aName.
! !

!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:49'!
signal
	^ self at: 2
! !

!ResourceEvent methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:51'!
signal: aSignal
	self at: 2 put: aSignal.
! !


!Tuple class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:22'!
example
	"Example of tuple matching" 

	^ ( 5 | nil | $f | Point ) 
		match: 
			( Integer | UndefinedObject | $f | (2@3) )! !

!Tuple class methodsFor: 'as yet unclassified' stamp: 'bolot 8/2/1999 23:23'!
fork: aBlock
	"Creates an eval process"

	^ Subspace fork: aBlock! !

!Tuple class methodsFor: 'instance creation' stamp: 'rww 7/14/2000 02:04'!
defaultArity
	^0! !

!Tuple class methodsFor: 'instance creation' stamp: 'rww 7/14/2000 02:04'!
new
	^super new initialize! !

!Tuple class methodsFor: 'instance creation' stamp: 'rww 7/27/2000 23:28'!
with: anObject
	^ self new 
		add: anObject;
		yourself
! !

!Tuple class methodsFor: 'instance creation' stamp: 'rww 7/27/2000 23:28'!
with: obj1 with: obj2
	^ self new 
		add: obj1;
		add: obj2;
		yourself

! !


!InternalLindaEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:12'!
defaultArity
	^ 4! !

!InternalLindaEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:14'!
defaultPriority
	^ Processor userSchedulingPriority 
! !

!InternalLindaEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:14'!
eventSymbol: aSymbol tuple: aTuple result: aResult
	^ self 
		eventSymbol: aSymbol
		tuple: aTuple
		result: aResult
		priority: self defaultPriority
! !

!InternalLindaEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:47'!
eventSymbol: aSymbol tuple: aTuple result: aResult priority: aPriority
	^ super new
		eventSymbol: aSymbol;
		tuple: aTuple;
		result: aResult;
		priority: aPriority;
		yourself
! !


!InternalLindaEventNotification class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:12'!
defaultArity
	^ 2! !

!InternalLindaEventNotification class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 01:11'!
whenMatch: aTuple perform: aMessageSend
	^ super new
		initializeOnMatch: aTuple
		messageSend: aMessageSend
! !


!ResourceEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:43'!
defaultArity
	^ 4! !

!ResourceEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:43'!
defaultPriority
	^ Processor userSchedulingPriority 
! !

!ResourceEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:46'!
resourceName: aName signal: aSignal data: theData
	^ self
		resourceName: aName
		signal: aSignal
		data: theData
		priority: self defaultPriority

! !

!ResourceEvent class methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 04:46'!
resourceName: aName signal: aSignal data: theData priority: aPriority
	^ super new
		resourceName: aName;
		signal: aSignal;
		data: theData;
		priority: aPriority;
		yourself
! !


!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:11'!
compact
	"Deletes empty partitions"

	(self subspaces select: [:x | x isEmpty] ) keysDo: [:size | self subspaces removeKey: size]! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 23:16'!
copy
	"Returns a copy of the TupleSpace"
	| copy dic |

	copy := super copy.
	dic := Dictionary new.
	self subspaces associationsDo: [ :assoc | dic at: assoc key put: assoc value copy ].
	copy subspaces: dic.
	^ copy! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:11'!
eval: tuple
	"Forwards the eval primitive to the right partition"

	( self sub: tuple ) eval: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:12'!
flush
	"Flushes (emties) the TupleSpace"

	^ self initialize! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:12'!
in: tuple
	"Forwards the in primitive to the right partition"

	^ ( self sub: tuple ) in: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 23:16'!
initialize
	"Initializes the Dictionary that stores
	the TupleSpace partitions (Subspaces).
	These partition are based on the tuple arity"

	self subspaces:  Dictionary new! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:13'!
inp: tuple
	"Forwards the inp primitive to the right partition"

	^ ( self sub: tuple ) inp: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:14'!
justEval: tuple
	"Forwards the justEval primitive to the right partition"

	( self sub: tuple ) justEval: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:14'!
out: tuple
	"Forwards the out primitive to the right partition"

	( self sub: tuple ) out: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:14'!
outi: tuple
	"Forwards the outi primitive to the right partition"

	( self sub: tuple ) outi: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:15'!
partitions
	"Returns a collection of partitions with tuples
	(e.g.  #(1 5 8 9) )."  

	^ subspaces keys asSortedCollection! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:15'!
rd: tuple
	"Forwards the rd primitive to the right partition"

	^ ( self sub: tuple ) rd: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:15'!
rdp: tuple
	"Forwards the rdp primitive to the right partition"

	^ ( self sub: tuple ) rdp: tuple! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 23:18'!
scan: tuple
	"Forwards the scan primitive to the right partition"

	^ (self sub: tuple) scan: tuple
! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:16'!
sub: tuple
	"Returns the subspace for the tuple.
	This is like hashing a big TuplaSpace in
	subspaces based on tuple sizes."

	^ self subspaceForArity:   tuple arity! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 23:17'!
subspaceForArity: tupleArity
	"Returns the subspace where the tuples of a given
	size are stored, etc."

	| newSub |

	^ subspaces
		at: tupleArity
		ifAbsent:
			[subspaces
				at: tupleArity
				put: ( newSub := Subspace new).
			^ newSub ]! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'bolot 8/3/1999 00:17'!
subspaces
	"Returns the dictionary    size -> subspace"

	^ subspaces! !

!TupleSpace methodsFor: 'as yet unclassified' stamp: 'rww 7/27/2000 23:17'!
subspaces: aDictionary
	"Changes the subspaces dictionary"

	subspaces := aDictionary! !

!TupleSpace methodsFor: 'errors' stamp: 'rww 7/14/2000 02:04'!
errorNotKeyed
	self lindaError new messageText: 'TupleSpace is not keyed'; signal.! !

!TupleSpace methodsFor: 'errors' stamp: 'rww 7/14/2000 02:04'!
lindaError

	^self class lindaError.! !

!TupleSpace methodsFor: 'errors' stamp: 'rww 7/14/2000 02:04'!
tupleNotFound
	self lindaError new messageText: 'Tuple not found'; signal.! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
add: aTuple
	^self out: aTuple! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
detect: aTupleTemplate
	^self detect: aTupleTemplate ifNone: [self tupleNotFound].! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
detect: aTupleTemplate ifNone: aNoneBlock
	|result|
	result := self rdp: aTupleTemplate.
	^ result ifNil: [aNoneBlock value].! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
includes: aTupleTemplate
	^self subspaces includes: aTupleTemplate! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
remove: aTupleTemplate
	^self remove: aTupleTemplate ifNone: [self tupleNotFound].! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
remove: aTupleTemplate ifNone: aNoneBlock
	|result|
	result := self inp: aTupleTemplate.
	^result ifNil: [aNoneBlock value].! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
removeAll: aTupleTemplate
	|all|
	all := self scan: aTupleTemplate.
	all do: [:e | self remove: e].
	^all! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/14/2000 02:04'!
select: aTupleTemplate 
	^self scan: aTupleTemplate.! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/26/2000 17:14'!
syncDetect: aTupleTemplate
	^ self rd: aTupleTemplate.
! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/26/2000 17:14'!
syncRemove: aTupleTemplate
	^ self in: aTupleTemplate! !

!TupleSpace methodsFor: 'Collection API' stamp: 'rww 7/24/2000 09:16'!
transientAdd: aTuple
	^self outi: aTuple! !

!TupleSpace methodsFor: 'Collection API - not impl' stamp: 'rww 7/14/2000 02:04'!
at: index
	self errorNotKeyed! !

!TupleSpace methodsFor: 'Collection API - not impl' stamp: 'rww 7/14/2000 02:04'!
at: index put: anObject
	self errorNotKeyed! !

!TupleSpace methodsFor: 'Collection API - not impl' stamp: 'rww 7/14/2000 02:04'!
collect: aTupleTemplate 
	self notYetImplemented.! !

!TupleSpace methodsFor: 'Collection API - not impl' stamp: 'rww 7/14/2000 02:04'!
do: anEvalTuple 
	self notYetImplemented.! !


!EventTupleSpace methodsFor: 'threads' stamp: 'rww 7/26/2000 01:53'!
addThread
	| proc|
	proc := LindaEventThread newOnEventTupleSpace: self.
	self threadPool add: proc.
	proc startHandlingEvents.! !

!EventTupleSpace methodsFor: 'threads' stamp: 'rww 7/28/2000 00:40'!
changeThreadPoolSize: aSize
	self eval: ('ChangeThreadCount' | [
			|differentialInNumber|
			differentialInNumber _ aSize - self threadPoolSize.
			(differentialInNumber > 0)
				ifTrue: [differentialInNumber timesRepeat: [self addThread]]
				ifFalse: [differentialInNumber abs timesRepeat: [self removeThread]].
			self threadPoolSize ] ).

! !

!EventTupleSpace methodsFor: 'threads' stamp: 'rww 7/26/2000 02:08'!
defaultThreadPoolSize
	^ self class defaultThreadPoolSize! !

!EventTupleSpace methodsFor: 'threads' stamp: 'rww 7/26/2000 01:54'!
removeThread
	self threadPoolSize > 0 
		ifTrue: [|proc|
			proc := self threadPool first.
			proc stopHandlingEvents.
			self threadPool remove: proc].! !

!EventTupleSpace methodsFor: 'threads' stamp: 'rww 7/28/2000 00:22'!
threadPoolSize
	self remove: ('ChangeThreadPoolSize' | Integer) ifNone: [].
	^self threadPool size.

! !

!EventTupleSpace methodsFor: 'threads' stamp: 'rww 7/28/2000 00:17'!
threadPoolSize: aSize
	self changeThreadPoolSize: aSize.
! !

!EventTupleSpace methodsFor: 'errors' stamp: 'rww 7/28/2000 00:37'!
signalEventProcessingOff
	self lindaError new 
		messageText: 'Events processing off';
		signal.
! !

!EventTupleSpace methodsFor: 'event queue' stamp: 'rww 7/28/2000 00:38'!
dequeueEvent
	(self isProcessingEvents)
		ifTrue: [^ self eventQueue next]
		ifFalse: [^ self signalEventProcessingOff].
! !

!EventTupleSpace methodsFor: 'event queue' stamp: 'rww 7/28/2000 00:35'!
enqueueEvent: anEvent
	(self isProcessingEvents)
		ifTrue: [self eventQueue nextPut: anEvent].

! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/27/2000 04:20'!
processNextEvent
	| event |
	event := self dequeueEvent
		ifNil: [^nil].
	self 
		trigger: event eventSymbol 
		withArguments: event arguments.

! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/26/2000 17:18'!
queuedEventsSize
	^ self eventQueue size! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/28/2000 00:34'!
startEventProcessing
	isProcessingEvents := true.
! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/28/2000 00:34'!
stopEventProcessing
	isProcessingEvents := false.
! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/28/2000 00:24'!
waitForEventsToFlush
	[self queuedEventsSize = 0]
			whileFalse: [(Delay forMilliseconds: 100) wait].
! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/27/2000 04:52'!
when: anEventSymbol match: aTupleTemplate perform: aMessageSend
	| eventNotification |
	eventNotification := InternalLindaEventNotification 
		whenMatch: aTupleTemplate
		perform: aMessageSend.
	super when: anEventSymbol perform: eventNotification.

! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/24/2000 09:38'!
when: anEventSymbol match: aTupleTemplate send: aSelector to: aTarget
	self
		when: anEventSymbol
		match: aTupleTemplate
		perform: (MessageSend receiver: aTarget selector: aSelector)! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/24/2000 09:40'!
when: anEventSymbol match: aTupleTemplate send: aSelector to: aTarget with: anArg
	self
		when: anEventSymbol
		match: aTupleTemplate
		perform: (MessageSend receiver: aTarget selector: aSelector argument: anArg)! !

!EventTupleSpace methodsFor: 'events' stamp: 'rww 7/24/2000 09:39'!
when: anEventSymbol match: aTupleTemplate send: aSelector to: anObject withArguments: anArray
	self
		when: anEventSymbol
		match: aTupleTemplate
		perform: (MessageSend receiver: anObject selector: aSelector arguments: anArray)! !

!EventTupleSpace methodsFor: 'accessors' stamp: 'rww 7/26/2000 06:17'!
eventQueue
	^ eventQueue
! !

!EventTupleSpace methodsFor: 'accessors' stamp: 'rww 7/28/2000 00:36'!
isProcessingEvents
	^ isProcessingEvents
! !

!EventTupleSpace methodsFor: 'accessors' stamp: 'rww 7/26/2000 02:23'!
subspaceForArity: tupleArity
	"Returns the subspace where the tuples of a given
	size are stored, etc."

	| newSub |

	^ subspaces
		at: tupleArity
		ifAbsent:
			[subspaces
				at: tupleArity
				put: ( newSub := EventSubspace newForSpace: self).
			^ newSub ]! !

!EventTupleSpace methodsFor: 'accessors' stamp: 'rww 7/25/2000 23:22'!
threadPool
	^ threadPool
! !

!EventTupleSpace methodsFor: 'initialize-release' stamp: 'rww 7/28/2000 00:39'!
initialize
	super initialize.
	threadPool := OrderedCollection new.
	eventQueue := SharedPriorityQueue new.
	eventQueue sortBlock: [:a :b |
		((a respondsTo: #priority) and: [b respondsTo: #priority])
			ifTrue: [a priority > b priority]
			ifFalse: [a hash < b hash]].
	self stopEventProcessing.
	self threadPoolSize: self defaultThreadPoolSize.
	self startEventProcessing.! !

!EventTupleSpace methodsFor: 'initialize-release' stamp: 'rww 7/27/2000 06:50'!
printReadOn: stream tuple: aMatchTuple
	stream cr; 
		nextPutAll: 'ReadEvent received: ';
		nextPutAll: (aMatchTuple at: 3).
! !

!EventTupleSpace methodsFor: 'initialize-release' stamp: 'rww 7/27/2000 06:49'!
printWriteOn: stream tuple: aMatchTuple
	stream cr; 
		nextPutAll: 'WriteEvent received: ';
		nextPutAll: (aMatchTuple at: 3).
! !

!EventTupleSpace methodsFor: 'initialize-release' stamp: 'rww 7/28/2000 00:32'!
release
	self threadPoolSize: 0.
	self threadPoolSize.
	self waitForEventsToFlush.
	self stopEventProcessing.
	self removeAllEventsTriggered.
	self compact.

! !

!EventTupleSpace methodsFor: 'initialize-release' stamp: 'rww 7/26/2000 15:46'!
store: stream tuple: aMatchTuple
	stream cr; 
		nextPutAll: 'Event received: ';
		nextPutAll: (aMatchTuple at: 3).
! !


!TupleSpace class methodsFor: 'instance creation' stamp: 'bolot 8/3/1999 00:20'!
new
	"Returns a new tuple space"

	^ super new initialize! !

!TupleSpace class methodsFor: 'examples' stamp: 'rww 7/28/2000 00:59'!
example
	self example: 100.

! !

!TupleSpace class methodsFor: 'examples' stamp: 'rww 7/28/2000 00:58'!
example: numberOfTupleToWrite
	self 
		example: numberOfTupleToWrite 
		priority: Processor userSchedulingPriority.
! !

!TupleSpace class methodsFor: 'examples' stamp: 'rww 7/28/2000 00:58'!
example: numberOfTupleToWrite priority: aPriority
	[	"Run the following code..."
		| tupleSpace count sem1 time1 sem2 time2 |

		tupleSpace := TupleSpace new.

		sem1 := Semaphore new.
		sem2 := Semaphore new.
		count := 1.
		[
			time1 := Time millisecondsToRun: [numberOfTupleToWrite timesRepeat: [
					(Delay forMilliseconds: 1) wait.
					tupleSpace
						add: ('Socket' | 1 | ('Squeak Rulez!!->1.', count printString) ).
					count := count + 1.
			].
			sem1 signal].
		] forkAt: aPriority.
		[
			time2 := Time millisecondsToRun: [numberOfTupleToWrite timesRepeat: [
					(Delay forMilliseconds: 1) wait.
					tupleSpace
						syncRemove: ('Socket' | 1 | String).
			].
			sem2 signal].
		] forkAt: aPriority.

		sem1 wait.
		sem2 wait.
		Transcript cr; 
			cr; cr;
			show: 'TupleSpace performance with Priority: ', aPriority printString, '!!';
			cr;
			show: '***   time to add ', numberOfTupleToWrite printString, ' tuples: ';
			show: ((time1 - numberOfTupleToWrite) / 1000) asFloat printString;
			cr;
			show: '***   time to remove ', numberOfTupleToWrite printString, ' tuples: ';
			show: ((time2 - numberOfTupleToWrite) / 1000) asFloat printString;
			cr;
			show: '***   tuple process rate: ';
			show: (numberOfTupleToWrite*1000/(time1 + time2 - numberOfTupleToWrite)) asFloat printString;
			show: ' (tuples/second) '.
		tupleSpace release.
	]  forkAt: Processor userBackgroundPriority.
! !

!TupleSpace class methodsFor: 'documentation' stamp: 'bolot 8/3/1999 13:31'!
basicExample
	"Alguns exemplos simples de utilizacao de Linda.
	Por via das duvidas, execute antes:

	Simple Linda example.
	Execute the following before running this example:

	TimeSlicer reinitialize.
	TupleSpace inicializaTupleSpaceDefault."

    "Selecione as tres linhas abaixo e execute com showIt"
	"It selects tres strings below and it executes with showIt"

	( 'factorial' | 3 | [ 3 factorial] ) eval.
	( 'factorial' | 6 | [ 6 factorial] ) eval.
	( 'factorial' | Integer | Integer ) in.

	"Selecione as duas linhas abaixo e execute com showIt"
	"It selects the two strings below and it executes with showIt"

	( 'mouse' | [ [Cursor sense y < 10] whileFalse: [].
		"Terminal bell." Cursor sense] ) eval.
	( 'mouse' | Point ) rd.
	( 'mouse' | Point ) in.

	"Selecione as duas linhas abaixo e execute com showIt"
	"It selects the two strings below and it executes with showIt"

	( 'mouse'
	| [ [Cursor sense y < 10]
		whileFalse: [Time now printString displayAt: 100 @ 20]. Cursor sense x]
	| [ [Cursor sense x < 10]
		whileFalse: [Time now printString displayAt: 3 @ 100]. Cursor sense y] ) eval.
	( 'mouse' | Integer | Integer ) in.! !

!TupleSpace class methodsFor: 'documentation' stamp: 'bolot 8/3/1999 14:08'!
exemploDesenho
	"Exemplo do uso de Linda para despachar mensagens
	para um objeto Smalltalk, no estilo cliente-servidor. 
	Aqui e' criada uma tupla viva, que despacha mensagens para uma
	outra tartaruga desenhar. O eval, entao,
	comporta-se como uma tartaruga servidora.

	Example of use of forwarding messages for a Smalltalk object,
	in the style client-server. Here one live tuple is created, and it forwards
	messages to another turtle to draw. The eval, entao, behave as a serving turtle"

	( 'GC' |  [ self exemploDesenhoTartServidora ] ) eval.
	"Dispara um processo que despacha mensagens"
	"A process goes off that forwards messages"

	('GC' | 1 |
		(Message new
			setSelector: #displayLineFrom:to:  
			arguments: ( Array with: (0@0) with: (100@100)  );
			yourself)
	) out.

	('GC' | 2 |
		(Message new
			setSelector: #displayString:at: 
			arguments: ( Array with: ('cliente-servidor em LindaTalk') with: (60 @ 60) );
			yourself)
	) out.

	('GC' | 3 |
		(Message new
			setSelector: #displayRectangle:at:  
			arguments: (Array with: (50@10 extent: 50 @ 50) with: ( 60 @ 10) );
			yourself)
	) out.

	('GC' | 4 |  (Message new)  ) out.  "Manda processo terminar - It orders process to finish "
	^ ('GC' | Object )  in.         "Espera processo terminar - Wait process to finish"! !

!TupleSpace class methodsFor: 'documentation' stamp: 'bolot 8/3/1999 12:26'!
exemploDesenhoTartServidora
	"Aqui implementa-se o kernel do tratamento de
	mensagens a serem despachadas. Sequencialmente,
	uma-a-uma, as mensagens sao tratadas.  Veja o
	metodo #exemploDesenho

	Here kernel of the handling of messages is implemented to be dispatched.
	Sequentially, uma-a-uma, the treated messages sao. (It) sees method #exemploDesenho "

	| tupla gc service |
	Transcript show: '*** Comecando .... ***'.
	gc :=  ScheduledControllers activeController view graphicsContext.
	service := 1.
	[tupla := ( 'GC' | service | Message ) in .
	Transcript show: '**desenhar!! - to draw!!**'.
	(tupla @ 3 ) selector isNil]
		whileFalse:
			[gc perform: (tupla @ 3) selector
				withArguments: (tupla @ 3) arguments ].
	^ 'fim'! !

!TupleSpace class methodsFor: 'documentation' stamp: 'bolot 8/3/1999 12:33'!
exemploEfeitoColateral
	"Exemplo para testar se a tupla in e' alterada ou
	se e' retornada uma nova tupla.
	Avalie antes o seguinte codigo:

	Example to test if a tuple in and modified or if and returned new tuple.
	Evaluate the following before running this example:

	TupleSpace initDefaultTupleSpace"


	| tuplaOut1 tuplaOut2 tuplaIn1 tuplaIn2 tuplaMatch |

	tuplaOut1 _ ( 23 | 'ver' ). " ver = to see "
	tuplaOut2 _ ( 24 | 'ver' ).
	tuplaMatch _ ( Integer | String ).

	tuplaOut1 out.
	tuplaOut2 out.

	tuplaIn1 _ tuplaMatch inp.
	tuplaIn1 isNil
		ifTrue: [ ^'Erro no espaco de tuplas - Error in the tuple space'].
			"Nao deveria dar erro aqui !!!!!!!!!!!!"
			"Nao would have to raise an error here!!!!!!!!!!!!"
	tuplaIn2 _ tuplaMatch inp.
	tuplaIn2 isNil
		ifTrue: [ ^'Esta implementacao possui efeito colateral - ',
				'This implementacao possesss collateral effect'].
			"Nao deveria dar erro aqui se a implementacao fosse puramente funcional,
			ou seja, caso nao se alterasse a tupla match quando de uma primitiva
			de leitura do espaco. Dever-se-ia retornar uma nova tupla, que seria
			o resultado do match"
			"Nao would have to give error here if implementation was purely functional,
			or either, case nao if match when of a primitive of reading of the space modified tuple.
			Tuple would have to be returned new, that it would be the result of match"
	^ 'Esta implementacao nao possui efeito colateral - ',
		'This implementacao nao possesss collateral effect'! !

!TupleSpace class methodsFor: 'documentation' stamp: 'bolot 8/3/1999 13:19'!
exemploRelogio
	"Exemplo do uso de Linda. Criam-se tuplas vivas,
	que ficam mostrando a hora na tela. Quando se
	aproxima o cursor de algum dos relogios, a
	tupla viva transforma-se em uma tupla
	ordinaria. Por via das duvidas, execute antes:

	They create live tuples, which are showing time on the screen.
	When the cursor of some of the relogios is come close,
	live tuple is changed into an ordinary tuple.
	Execute the following before running this example:

	TimeSlicer reinitialize.
	TupleSpace initDefaultTupleSpace.

	TupleSpace exemploRelogio."

     ( 'relogio' | [ [(Cursor sense x - 0)   abs <=   5]
                          whileFalse: [Time now printString displayAt: 0 @ 20].
                           Cursor sense x]    ) eval.

    ( 'relogio' | [ [(Cursor sense x - 100)   abs <=   5]
                          whileFalse: [Time now printString displayAt: 100 @ 20].
                           Cursor sense x]    ) eval.

    ( 'relogio' |  [ [(Cursor sense x - 200)   abs <=   5]
                          whileFalse: [Time now printString displayAt: 200 @ 20].
                           Cursor sense x]    ) eval.

    ( 'relogio' | [ [(Cursor sense x - 300)   abs <=   5]
                          whileFalse: [Time now printString displayAt: 300 @ 20].
                           Cursor sense x]    ) eval.

    ( 'relogio' | [ [(Cursor sense x - 400)   abs <=   5]
                          whileFalse: [Time now printString displayAt: 400 @ 20].
                           Cursor sense x]    ) eval.



   ^ ( 'relogio' | Integer ) in.! !

!TupleSpace class methodsFor: 'documentation' stamp: 'bolot 8/3/1999 13:28'!
exemplosDeMatching
	"Alguns casos onde ocorre e onde nao ocorre o
	matching de tuplas.

	Some cases where it occurs and where nao occur matching of tuplas"

	"Matching com parametros reais apenas.
	Execute as tres linhas que seguem com showIt"
	"Matching with real parametros only.
	It executes tres strings that follow with showIt"

	TupleSpace initDefaultTupleSpace.
	( (2@8) | 3 | 'marcio' ) out.
	( (2@8) | 3 | 'marcio' ) inp.

	"Matching com parametros reais e potenciais .
	Execute as tres linhas que seguem com showIt"
	"Matching with real and potential parametros.
	It executes tres strings that follow with showIt"

	TupleSpace initDefaultTupleSpace.
	( (2@8) | 3 | 'marcio' ) out.
	( (2@8) | Integer | String) inp.

	"Matching com parametros reais e potenciais,
	com dois potenciais, um em cada tupla.
	Execute as tres linhas que seguem com showIt"
	"Matching with real and potential parameters,
	two potentials, one in each tuple.
	It executes tres strings that follow with showIt"

	TupleSpace initDefaultTupleSpace.
	( (2@8) | Integer | 'marcio' ) out.
	( Point | Integer | 'marcio' ) inp.

	"Matching com parametros reais e potenciais,
	mas com o parametro real na tupla in e o
	potencial na tupla out.
	Execute as tres linhas que seguem com showIt"
	"Matching with real and potential parametros,
	but with parametro real in tupla in and the potential in tupla out.
	It executes tres strings that follow with showIt"

	TupleSpace initDefaultTupleSpace.
	( (2@8) | Integer | 'marcio' ) out.
	( Point | 5 | String) inp.! !

!TupleSpace class methodsFor: 'documentation' stamp: 'bolot 8/3/1999 13:31'!
exemplosNaoBloqueantes
	"Exemplo do uso de Linda. O objetivo aqui
	e' mostrar o comportamento das primitivas
	nao-bloqueantes (rdp e inp)

	Example of the behavior of the non-blocking primitives (rdp and inp)"

	"Selecione as tres linhas abaixo e execute com showIt"
	"Select the strings below and execute with showIt"

	( 'fatorial' | 3 | [ 3 factorial] ) eval.
	( 'fatorial' | 6 | [ 6 factorial] ) eval.
	( 'fatorial' | Integer | Integer ) inp.

	"Selecione as duas linhas abaixo e execute com showIt"
	"Select the strings below and execute with showIt"

	( 'mouse' | [ [Cursor sense y < 10] whileFalse: [].
		"Terminal bell." Cursor sense] ) eval.
	( 'mouse' | Point ) rdp.
	( 'mouse' | Point ) inp.

	"Selecione as duas linhas abaixo e execute com showIt"
	"Select the strings below and execute with showIt"

	( 'mouse'
	| [ [Cursor sense y < 10]
		whileFalse: [Time now printString displayAt: 100 @ 20]. Cursor sense x]
	| [ [Cursor sense x < 10]
		whileFalse: [Time now printString displayAt: 3 @ 100]. Cursor sense y] ) eval.

	( 'mouse' | Integer | Integer ) inp.! !

!TupleSpace class methodsFor: 'documentation' stamp: 'rww 7/28/2000 01:38'!
philExample
	"TupleSpace philExample."

	^self philExampleWithNumber: 5.
! !

!TupleSpace class methodsFor: 'documentation' stamp: 'rww 7/28/2000 01:38'!
philExampleWithNumber: aNum
	"TupleSpace philExample."

	| numPhil tupleSpace |

	tupleSpace := TupleSpace new.
	numPhil := aNum.	"Number of philosophers"
	('numberOfPhilosophers' | numPhil ) out: tupleSpace.	"Constants should be kept in tuple space"
	1 to: numPhil do: [ :i |
		('Phil #', i printString, ' now alive...') displayAt: 10@(i*20).
		('fork' | i ) out: tupleSpace.		"Creates the Nth fork"
		('phil' | i ) out: tupleSpace.		"Philosopher's ID"
		('phil' | [self philLife: tupleSpace] ) eval: tupleSpace.	"Creates the philosopher"
		"Give tickets to be used to enter the room"
		i < numPhil
			ifTrue: [ #( 'ticket') asTuple out: tupleSpace]].
	^ tupleSpace.
! !

!TupleSpace class methodsFor: 'documentation' stamp: 'rww 7/28/2000 01:37'!
philLife: tupleSpace

	| phils numPhils myId myself|

	phils := ('numberOfPhilosophers' | Integer ) rd: tupleSpace.   "Read the constant"
	numPhils := phils at: 2.
	myself := ('phil' | Integer ) in: tupleSpace.	"Get my ID"
	myId := myself @ 2.				"Get my ID"

	10 timesRepeat: [
		('Phil #', myId printString, ' now thinking...') displayAt: 10@(myId*20).
		(Delay forMilliseconds: 200) wait.	"Think for a while..."
	   
		#( 'ticket') asTuple in: tupleSpace.					"Obtain a ticket to eat"
		('fork' | myId ) in: tupleSpace.						"Get my left fork"
		('fork' | ((myId \\ numPhils) + 1) ) in: tupleSpace.	"Get my right fork"

		('Phil #', myId printString, ' now eating...') displayAt: 10@(myId*20).
		(Delay forMilliseconds: 200) wait.	"Eat for a while..."
	  
		('fork' | myId) out: tupleSpace.						"Puts the left fork back on the table"
		('fork' | ((myId \\ numPhils) + 1)) out: tupleSpace.	"Same with the right one"
		#( 'ticket') asTuple out: tupleSpace.					"Returns the ticket"
	].
	('Phil #', myId printString, ' now done...') displayAt: 10@(myId*20).
	^ Array with: myId with: 'fim'! !

!TupleSpace class methodsFor: 'error handling' stamp: 'rww 7/14/2000 02:04'!
lindaError
	^LindaError! !


!EventTupleSpace class methodsFor: 'examples' stamp: 'rww 7/28/2000 00:59'!
example
	self example: 100.

! !

!EventTupleSpace class methodsFor: 'examples' stamp: 'rww 7/28/2000 00:28'!
example: numberOfTupleToWrite
	self 
		example: numberOfTupleToWrite 
		threadCount: 5.
! !

!EventTupleSpace class methodsFor: 'examples' stamp: 'rww 7/28/2000 00:28'!
example: numberOfTupleToWrite threadCount: threadCount
	self 
		example: numberOfTupleToWrite 
		threadCount: threadCount 
		priority: Processor userSchedulingPriority.
! !

!EventTupleSpace class methodsFor: 'examples' stamp: 'rww 7/28/2000 01:11'!
example: numberOfTupleToWrite threadCount: threadCount priority: aPriority
	[	"Run the following code..."
		| eventfulTupleSpace stream count sem1 sem2 time1 time2 |

		eventfulTupleSpace := EventTupleSpace new.
		eventfulTupleSpace threadPoolSize: threadCount.
		stream := ReadWriteStream on: ''.
		eventfulTupleSpace
			when: #write 
			match: ('Socket' | 1 | String )
			send: #printWriteOn:tuple:
			to: eventfulTupleSpace
			with: stream.

		sem1 := Semaphore new.
		sem2 := Semaphore new.
		count := 1.
		[
			time1 := Time millisecondsToRun: [numberOfTupleToWrite timesRepeat: [
					(Delay forMilliseconds: 1) wait.
					eventfulTupleSpace
						add: ('Socket' | 1 | ('Squeak Rulez!!->1.', count printString) ).
					count := count + 1.
			].
			sem1 signal].
		] forkAt: aPriority.
		[
			time2 := Time millisecondsToRun: [numberOfTupleToWrite timesRepeat: [
					(Delay forMilliseconds: 1) wait.
					eventfulTupleSpace
						syncRemove: ('Socket' | 1 | String).
			].
			sem2 signal].
		] forkAt: aPriority.

		sem1 wait.
		sem2 wait.
		eventfulTupleSpace waitForEventsToFlush.

		Transcript cr; 
			cr; cr;
			show: 'EventTupleSpace performance with Priority: ', aPriority printString, '!!';
			cr;
			show: '***   time to add ', 
					numberOfTupleToWrite printString, 
					' tuples (with events): ';
			show: ((time1 - numberOfTupleToWrite) / 1000) asFloat printString;
			cr;
			show: '***   time to remove ', 
					numberOfTupleToWrite printString, 
					' tuples (with events): ';
			show: ((time2 - numberOfTupleToWrite) / 1000) asFloat printString;
			cr;
			show: '***   tuple process rate: ';
			show: (numberOfTupleToWrite*1000/(time1 + time2 - numberOfTupleToWrite)) asFloat printString;
			show: ' (tuples/second) '.

		eventfulTupleSpace release.
	]  forkAt: Processor userBackgroundPriority.
! !

!EventTupleSpace class methodsFor: 'settings' stamp: 'rww 7/26/2000 13:32'!
defaultThreadPoolSize
	^ 3! !

!EventTupleSpace class methodsFor: 'development' stamp: 'rww 7/28/2000 01:36'!
openWorkspace

|workspace|
workspace := Workspace new.
workspace contents: '
"The following are performance tests for the LindaTalk.  Open a transcript and run"
"Performance criteria"
	TupleSpace example: 200.    " User background priority "
	TupleSpace example: 200 priority: Processor highIOPriority.
	TupleSpace example: 200 priority: Processor userBackgroundPriority.

	EventTupleSpace example: 200 threadCount: 10.   " User background priority "
	EventTupleSpace example: 200 threadCount: 2 priority: Processor highIOPriority.
	EventTupleSpace example: 200 threadCount: 2 priority: Processor userBackgroundPriority. 

"Philosopher''s problem from Bolot"
TupleSpace philExample.
TupleSpace philExampleWithNumber: 30.

"This is a broken Whiteboard example"
WhiteboardClient exampleHeadlessWhiteboard.
'.
workspace openLabel: 'LindaTalk Workspace'.
! !


!WhiteboardClient methodsFor: 'accessors' stamp: 'rww 7/27/2000 05:29'!
bufferStream
	^ bufferStream ifNil: [bufferStream := ReadWriteStream on: '']
! !

!WhiteboardClient methodsFor: 'accessors' stamp: 'rww 7/27/2000 05:29'!
bufferStream: aStream
	bufferStream := aStream.

! !

!WhiteboardClient methodsFor: 'accessors' stamp: 'rww 7/25/2000 21:54'!
userName
	^userName
! !

!WhiteboardClient methodsFor: 'accessors' stamp: 'rww 7/25/2000 09:46'!
users
	^ (self whiteboard select: (#user | String))
		collect: [:each | each at: 2]
! !

!WhiteboardClient methodsFor: 'accessors' stamp: 'rww 7/25/2000 04:24'!
whiteboard
	^ whiteboard! !

!WhiteboardClient methodsFor: 'actions' stamp: 'rww 7/25/2000 21:42'!
close
	self logout.
! !

!WhiteboardClient methodsFor: 'actions' stamp: 'rww 7/25/2000 21:55'!
login
	self userName
		ifNil: [^self error: 'No user name set'].
	self whiteboard add: (#user | self userName).
	self setupHandlers.
! !

!WhiteboardClient methodsFor: 'actions' stamp: 'rww 7/25/2000 16:48'!
logout
	self closeHandlers.
	self whiteboard 
		remove: (#user | self userName)
		ifNone: [].

! !

!WhiteboardClient methodsFor: 'actions' stamp: 'rww 7/25/2000 04:49'!
nextPut: aChar
	self shouldNotImplement.
! !

!WhiteboardClient methodsFor: 'actions' stamp: 'rww 7/25/2000 04:49'!
nextPutAll: aString
	self sendMessage: aString.
! !

!WhiteboardClient methodsFor: 'actions' stamp: 'rww 7/25/2000 04:29'!
sendMessage: aString

	self whiteboard transientAdd: (#message | self userName | aString).! !

!WhiteboardClient methodsFor: 'initialize-release' stamp: 'rww 7/25/2000 04:21'!
closeHandlers
	self whiteboard removeEventsTriggeredFor: self.

! !

!WhiteboardClient methodsFor: 'initialize-release' stamp: 'rww 7/25/2000 21:48'!
initializeOn: aServer

	whiteboard := aServer.
! !

!WhiteboardClient methodsFor: 'initialize-release' stamp: 'rww 7/25/2000 21:48'!
initializeOn: aServer userName: aName

	whiteboard := aServer.
	userName := aName.
	self login.
! !

!WhiteboardClient methodsFor: 'initialize-release' stamp: 'rww 7/27/2000 05:30'!
initializeOn: aServer userName: aName outputStream: aStream

	whiteboard := aServer.
	userName := aName.
	bufferStream := aStream.
	self login.
! !

!WhiteboardClient methodsFor: 'initialize-release' stamp: 'rww 7/27/2000 03:01'!
setupHandlers
	self whiteboard
		when: #write
		match: (#user | String)
		send: #userRegistered:
		to: self.
	self whiteboard
		when: #take
		match: (#user | String)
		send: #userDeregistered:
		to: self.
	self whiteboard
		when: #write
		match: (#message | String | String)
		send: #messageReceived:
		to: self.

! !

!WhiteboardClient methodsFor: 'events' stamp: 'rww 7/25/2000 21:46'!
messageReceived: messageTuple

	self user: (messageTuple at: 2)
		sentMessage: (messageTuple at: 3).

! !

!WhiteboardClient methodsFor: 'events' stamp: 'rww 7/27/2000 05:23'!
user: senderUserName sentMessage: aMessage


	Transcript cr; 
		nextPutAll: 'Message <from: ';
		nextPutAll: senderUserName;
		nextPutAll: '>   ';
		nextPutAll: aMessage.
! !

!WhiteboardClient methodsFor: 'events' stamp: 'rww 7/25/2000 04:26'!
userDeregistered: userTuple

	Transcript cr; 
		show: 'New user deregistered: ';
		show: userTuple.! !

!WhiteboardClient methodsFor: 'events' stamp: 'rww 7/25/2000 05:23'!
userRegistered: userTuple

	Transcript cr; 
		show: 'New user registered: ';
		show: userTuple.! !

!WhiteboardClient methodsFor: 'view' stamp: 'rww 7/25/2000 16:46'!
getUserNameFromUser
	userName := FillInTheBlank
		request: 'Please enter a user name'
		initialAnswer: 'Squeaker!!'.
	^ self userName
! !

!WhiteboardClient methodsFor: 'view' stamp: 'rww 7/25/2000 16:14'!
messagesText
	^ '' asText! !

!WhiteboardClient methodsFor: 'view' stamp: 'rww 7/25/2000 16:55'!
openAsMorph
	| win usersPane messagesPane entryPane |

	"build views"
	win _ SystemWindow labelled: 'Linda Chatter'.
	win model: self.

	usersPane _ PluggableListMorph 
			on: self 
			list: #usersTextList 
			selected: #usersTextListIndex 
			changeSelected: nil
			menu: #usersMenu:.
	win addMorph: usersPane frame: (0@0 extent: 0.2@1).

	messagesPane _ PluggableTextMorph on: self text: #messagesText accept: nil.
	win addMorph: messagesPane  frame: (0.2@0 extent: 0.8@0.8).

	entryPane _ PluggableTextMorph 
		on: self 
		text: #getMessages 
		accept: #sendMessage:.
	entryPane acceptOnCR: true.
	win addMorph: entryPane frame: (0.2@0.8 extent: 0.8@0.2).

	win openInWorld! !

!WhiteboardClient methodsFor: 'view' stamp: 'rww 7/25/2000 16:27'!
usersMenu: aMenu! !

!WhiteboardClient methodsFor: 'view' stamp: 'rww 7/25/2000 16:27'!
usersTextList
	^ self users collect: [:each | each asText].
! !

!WhiteboardClient methodsFor: 'view' stamp: 'rww 7/25/2000 16:27'!
usersTextListIndex
	^ 0! !


!WhiteboardClient class methodsFor: 'instance creation' stamp: 'rww 7/25/2000 21:28'!
chatter
	^ Chatter ifNil: [self resetChatter]! !

!WhiteboardClient class methodsFor: 'instance creation' stamp: 'rww 7/25/2000 16:13'!
new
	^ self chatter! !

!WhiteboardClient class methodsFor: 'instance creation' stamp: 'rww 7/25/2000 16:46'!
on: aServer
	^ super new 
		initializeOn: aServer
! !

!WhiteboardClient class methodsFor: 'instance creation' stamp: 'rww 7/25/2000 04:18'!
on: aServer userName: userName
	^ super new 
		initializeOn: aServer
		userName: userName
! !

!WhiteboardClient class methodsFor: 'instance creation' stamp: 'rww 7/25/2000 16:13'!
open
	^self new openAsMorph.! !

!WhiteboardClient class methodsFor: 'instance creation' stamp: 'rww 7/25/2000 21:28'!
resetChatter
	^ Chatter := WhiteboardClient on: EventTupleSpace new.! !

!WhiteboardClient class methodsFor: 'testing' stamp: 'rww 7/28/2000 01:31'!
exampleHeadlessWhiteboard
	"	WhiteboardClient exampleHeadlessWhiteboard"
	"Please execute the code below to test this"

	[
		| time tupleSpace client1 client2 client3 numberOfMessagesToSend |

		numberOfMessagesToSend := 5.
		tupleSpace := EventTupleSpace new.
		client1 := WhiteboardClient on: tupleSpace userName: 'slosher'.
		client2 := WhiteboardClient on: tupleSpace userName: 'bacchus'.
		client3 := WhiteboardClient on: tupleSpace userName: 'elbe'.

		time := Time millisecondsToRun: [
			WhiteboardClient 
				testClient: client1 
				tupleSpace: tupleSpace 
				lock: (#key | #token1) 
				message: 'I''m Squeaking and it''s fun!!'
				number: numberOfMessagesToSend.

			WhiteboardClient 
				testClient: client2 
				tupleSpace: tupleSpace 
				lock: (#key | #token2) 
				message: 'Java sucks!!'
				number: numberOfMessagesToSend.

			WhiteboardClient 
				testClient: client3 
				tupleSpace: tupleSpace 
				lock: (#key | #token3) 
				message: 'Squeak rulez!!'
				number: numberOfMessagesToSend.

			tupleSpace syncRemove: (#key | #token1).
			tupleSpace syncRemove: (#key | #token2).
			tupleSpace syncRemove: (#key | #token3).
		].

		tupleSpace waitForEventsToFlush.
		Transcript show: client1 bufferStream upToEnd.
		Transcript show: client2 bufferStream upToEnd.
		Transcript show: client3 bufferStream upToEnd.


		client1 close.
		client2 close.
		client3 close.
		tupleSpace release.
		Transcript cr; show: '****   execution time: ', (time / 1000) asFloat printString.
	] fork.
! !

!WhiteboardClient class methodsFor: 'testing' stamp: 'rww 7/25/2000 21:58'!
exampleMorphicWhiteboard
	"	WhiteboardClient exampleMorphicWhiteboard"
	WhiteboardClient open.

! !

!WhiteboardClient class methodsFor: 'testing' stamp: 'rww 7/25/2000 07:28'!
testClient: client tupleSpace: tupleSpace lock: lock message: aString
	self testClient: client tupleSpace: tupleSpace lock: lock message: aString number: 100.

! !

!WhiteboardClient class methodsFor: 'testing' stamp: 'rww 7/25/2000 07:27'!
testClient: client tupleSpace: tupleSpace lock: lock message: aString number: aNum
	| actorBlock  |
	actorBlock := [[
			aNum timesRepeat: [
				client nextPutAll: aString.
				(Delay forMilliseconds: 1) wait].
			tupleSpace add: lock.
		] fork.
	] fixTemps.

	actorBlock value.

! !


!WhiteboardClient class reorganize!
('instance creation' chatter new on: on:userName: open resetChatter)
('testing' exampleHeadlessWhiteboard exampleMorphicWhiteboard testClient:tupleSpace:lock:message: testClient:tupleSpace:lock:message:number:)
!


!WhiteboardClient reorganize!
('accessors' bufferStream bufferStream: userName users whiteboard)
('actions' close login logout nextPut: nextPutAll: sendMessage:)
('initialize-release' closeHandlers initializeOn: initializeOn:userName: initializeOn:userName:outputStream: setupHandlers)
('events' messageReceived: user:sentMessage: userDeregistered: userRegistered:)
('view' getUserNameFromUser messagesText openAsMorph usersMenu: usersTextList usersTextListIndex)
!


!EventTupleSpace class reorganize!
('examples' example example: example:threadCount: example:threadCount:priority:)
('settings' defaultThreadPoolSize)
('development' openWorkspace)
!


!TupleSpace class reorganize!
('instance creation' new)
('examples' example example: example:priority:)
('documentation' basicExample exemploDesenho exemploDesenhoTartServidora exemploEfeitoColateral exemploRelogio exemplosDeMatching exemplosNaoBloqueantes philExample philExampleWithNumber: philLife:)
('error handling' lindaError)
!


!EventSubspace class reorganize!
('instance creation' newForSpace:)
!

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

EventTupleSpace openWorkspace.
!

