'From Squeak2.8 of 13 June 2000 [latest update: #2348] on 28 July 2000 at 1:51:20 am'!
TestCase subclass: #LindaTalkTest
	instanceVariableNames: 'tupleSpace results '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Tests'!
LindaTalkTest subclass: #LindaTalkEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LindaTalk-Tests'!

!LindaTalkTest methodsFor: 'fixtures' stamp: 'rww 7/26/2000 17:03'!
results
	^ results! !

!LindaTalkTest methodsFor: 'fixtures' stamp: 'rww 7/27/2000 23:46'!
setUp

	tupleSpace := self tupleSpaceClass new.
	results := OrderedCollection new.! !

!LindaTalkTest methodsFor: 'fixtures' stamp: 'rww 7/26/2000 17:04'!
tearDown

	tupleSpace release.
! !

!LindaTalkTest methodsFor: 'fixtures' stamp: 'rww 7/26/2000 17:04'!
tupleSpace
	^ tupleSpace! !

!LindaTalkTest methodsFor: 'fixtures' stamp: 'rww 7/27/2000 23:47'!
tupleSpaceClass
	^ TupleSpace! !

!LindaTalkTest methodsFor: 'tests' stamp: 'rww 7/27/2000 23:54'!
testReadWriteWithTupleSpace

	| tuple1 tuple2 tuple3 |
	tuple1 := ('Admin' | ((Dictionary new) at: 2 put: (WriteStream on: ''); yourself)).
	tuple2 := ('Smalltalk' | 'ACL' | ((Array new: 2) at: 1 put: 'slosher'; at: 2 put: 'password'; yourself)).
	tuple3 := ('WorkQueue' | 'worker2' | 20).
	tupleSpace 
		add: tuple1;
		add: tuple2;
		add: tuple3.

	self assert: ((tupleSpace remove: ('Admin' | Dictionary ) ifNone: [nil]) = tuple1).
	self assert: ((tupleSpace remove: ('Smalltalk' | 'ACL' | Collection ) ifNone: [nil]) = tuple2).
	self assert: ((tupleSpace detect: ('WorkQueue' | 'worker2' | Integer ) ifNone: [nil]) = tuple3).
	self assert: ((tupleSpace remove: ('WorkQueue' | 'worker2' | Integer ) ifNone: [nil]) = tuple3).
! !


!LindaTalkEventTest methodsFor: 'fixtures' stamp: 'rww 7/26/2000 17:05'!
eventTriggered: tuple
	self results add: tuple.
! !

!LindaTalkEventTest methodsFor: 'fixtures' stamp: 'rww 7/26/2000 17:13'!
readTestEventsAndSignal: aSema
	| count |
	count := 1.

	[
		25 timesRepeat: [
			tupleSpace
				syncDetect: ('TestResource' | 42 | String ).
		].
		aSema signal.
	] fork.

	[
		25 timesRepeat: [
			tupleSpace
				add: ('TestResource' | 42 | ('Squeak Rulez!!->', count printString) ).
			count := count + 1.
		].
	] fork.

! !

!LindaTalkEventTest methodsFor: 'fixtures' stamp: 'rww 7/27/2000 02:58'!
scanTestEventsAndSignal: aSema
	| count |
	count := 1.
	[
		25 timesRepeat: [
			tupleSpace
				add: ('TestResource' | 42 | ('Squeak Rulez!!->', count printString) ).
			count := count + 1.
		].

		tupleSpace
			select: ('TestResource' | 42 | String ).
		aSema signal.
	] fork.

! !

!LindaTalkEventTest methodsFor: 'fixtures' stamp: 'rww 7/26/2000 17:13'!
takeTestEventsAndSignal: aSema
	| count |
	count := 1.


	[
		25 timesRepeat: [
			tupleSpace
				syncRemove: ('TestResource' | 42 | String ).
		].
		aSema signal.
	] fork.

	[
		25 timesRepeat: [
			tupleSpace
				add: ('TestResource' | 42 | ('Squeak Rulez!!->', count printString) ).
			count := count + 1.
		].
	] fork.

! !

!LindaTalkEventTest methodsFor: 'fixtures' stamp: 'rww 7/27/2000 23:47'!
tupleSpaceClass
	^ EventTupleSpace! !

!LindaTalkEventTest methodsFor: 'fixtures' stamp: 'rww 7/25/2000 06:14'!
writeTestEventsAndSignal: aSema
	| count |
	count := 1.
	[
		25 timesRepeat: [
			tupleSpace
				transientAdd: ('TestResource' | 42 | ('Squeak Rulez!!->', count printString) ).
			count := count + 1.
		].
		aSema signal.
	] fork.

! !

!LindaTalkEventTest methodsFor: 'tests' stamp: 'rww 7/27/2000 02:59'!
testEventsFromRead
	| sem |

	sem := Semaphore new.
	self tupleSpace
		when: #read 
		match: ('TestResource' | 42 | String )
		send: #eventTriggered:
		to: self.
	self readTestEventsAndSignal: sem.
	sem wait.

	[self tupleSpace queuedEventsSize = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].
	self should: [(self results size = 25)].
	self results do: [:e | 
		Transcript cr; show: e printString].
! !

!LindaTalkEventTest methodsFor: 'tests' stamp: 'rww 7/27/2000 02:59'!
testEventsFromScan
	| sem |

	sem := Semaphore new.
	self tupleSpace
		when: #scan
		match: ('TestResource' | 42 | String)
		send: #eventTriggered:
		to: self.
	self scanTestEventsAndSignal: sem.
	sem wait.

	[self tupleSpace queuedEventsSize = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].
	self should: [(self results size = 1)].
	self results do: [:e | 
		Transcript cr; show: e printString].
! !

!LindaTalkEventTest methodsFor: 'tests' stamp: 'rww 7/27/2000 02:59'!
testEventsFromTake
	| sem |

	sem := Semaphore new.
	self tupleSpace
		when: #take 
		match: ('TestResource' | 42 | String )
		send: #eventTriggered:
		to: self.
	self takeTestEventsAndSignal: sem.
	sem wait.

	[self tupleSpace queuedEventsSize = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].
	self should: [(self results size = 25)].
	self results do: [:e | 
		Transcript cr; show: e printString].
! !

!LindaTalkEventTest methodsFor: 'tests' stamp: 'rww 7/27/2000 02:59'!
testEventsFromWrite
	| sem |

	sem := Semaphore new.
	self tupleSpace
		when: #write 
		match: ('TestResource' | 42 | String )
		send: #eventTriggered:
		to: self.
	self writeTestEventsAndSignal: sem.
	sem wait.

	[self tupleSpace queuedEventsSize = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].
	self should: [(self results size = 25)].
	self results do: [:e | 
		Transcript cr; show: e printString].

! !


!LindaTalkEventTest reorganize!
('fixtures' eventTriggered: readTestEventsAndSignal: scanTestEventsAndSignal: takeTestEventsAndSignal: tupleSpaceClass writeTestEventsAndSignal:)
('tests' testEventsFromRead testEventsFromScan testEventsFromTake testEventsFromWrite)
!


!LindaTalkTest reorganize!
('fixtures' results setUp tearDown tupleSpace tupleSpaceClass)
('tests' testReadWriteWithTupleSpace)
!

